Pages/Admin/UserManage.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Project_PRN221_1.Models;

namespace Project_PRN221_1.Pages.Admin
{
    public class UserManageModel : PageModel
    {
        private readonly Project_PRN221_1Context _context;

        public UserManageModel(Project_PRN221_1Context context)
        {
            _context = context;
        }

        public List<Category> Categories { get; set; }

        public List<User> Users { get; set; }

        [BindProperty]
        public User u { get; set; } 
        public void OnGet()
        {
            Categories = _context.Categories.ToList();
            Users = _context.Users.Include(x => x.Role).ToList(); 

        }
        // delete user
        public IActionResult OnPost(int userId)
        {
			Categories = _context.Categories.ToList();
            
            var userToDelete = _context.Users.FirstOrDefault(u => u.UserId == userId);
            if (userToDelete != null)
            {
                var userPosts = _context.Posts.Where(p => p.UserId == userId).ToList();
                foreach (var post in userPosts)
                {
                    var postComments = _context.Comments.Where(c => c.PostId == post.PostId).ToList();
                    foreach (var comment in postComments)
                    {
                        _context.Comments.Remove(comment);
                    }
                    _context.Posts.Remove(post);
                }

                var userComments = _context.Comments.Where(c => c.UserId == userId).ToList();
                foreach (var comment in userComments)
                {
                    _context.Comments.Remove(comment);
                }
                _context.Users.Remove(userToDelete);
                _context.SaveChanges();
            }
            Users = _context.Users.Include(x => x.Role).ToList();
            return Page();
		}

        // set as censor
        public IActionResult OnPostSetCensor(int userId)
        {
            Categories = _context.Categories.ToList();
            var userToCensor = _context.Users.FirstOrDefault(u => u.UserId == userId);
            if (userToCensor != null)
            {
                userToCensor.RoleId = 3;
                _context.Users.Update(userToCensor);
                _context.SaveChanges();
            }
            Users = _context.Users.Include(x => x.Role).ToList();
            return Page();
        }
        //unset censor
        public IActionResult OnPostUnsetCensor(int userId)
        {
            Categories = _context.Categories.ToList();
            var userToUncensor = _context.Users.FirstOrDefault(u => u.UserId == userId);
            if (userToUncensor != null)
            {
                userToUncensor.RoleId = 1;
                _context.Users.Update(userToUncensor);
                _context.SaveChanges();
            }
            Users = _context.Users.Include(x => x.Role).ToList();
            return Page();
        }

        //deactive user
        public IActionResult OnPostDeactive(int userId)
        {
            Categories = _context.Categories.ToList();
            var userToDeactive = _context.Users.FirstOrDefault(u => u.UserId == userId);
            if (userToDeactive != null)
            {
                userToDeactive.IsActive = 0;
                _context.Users.Update(userToDeactive);
                _context.SaveChanges();
            }
            Users = _context.Users.Include(x => x.Role).ToList();
            return Page();
        }
    }
}

Pages/UserManage/Profile.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Project_PRN221_1.Models;

namespace Project_PRN221_1.Pages.UserManage
{
    public class ProfileModel : PageModel
    {
        private readonly Project_PRN221_1Context _context;

        public string ConfirmPassword;
        public ProfileModel(Project_PRN221_1Context context)
        {
            _context = context;
        }

        public List<Category> Categories { get; set; }
        [BindProperty]
        public User user { get; set; }

        public void OnGet()
        {
            Categories = _context.Categories.ToList();
            int uId = int.Parse(HttpContext.Session.GetString("UserId"));
            if (uId != null)
            {
                user = _context.Users.Include(r => r.Role).FirstOrDefault(u => u.UserId == uId);
            }
        }
        public IActionResult OnPostUpdateProfile()
        {
            Categories = _context.Categories.ToList();
            int uId = int.Parse(HttpContext.Session.GetString("UserId"));
            var userFromDb = _context.Users.AsNoTracking().FirstOrDefault(u => u.UserId == user.UserId);
            if (userFromDb != null)
            {
                if (userFromDb.Email != user.Email)
                {
                    var existingUser = _context.Users.FirstOrDefault(u => u.Email == user.Email);
                    if (existingUser != null)
                    {
                        user = _context.Users.Include(r => r.Role).FirstOrDefault(u => u.UserId == uId);
                        ModelState.AddModelError("user.Email", "Email already exists.");
                        return Page();
                    }
                    else
                    {
                        userFromDb.Email = user.Email;
                        _context.Entry(userFromDb).State = EntityState.Modified;
                        _context.SaveChanges();
                        user = _context.Users.Include(r => r.Role).FirstOrDefault(u => u.UserId == uId);
                    }
                }
                else
                {
                    userFromDb.Name = user.Name;
                    userFromDb.Email = user.Email;
                    _context.Entry(userFromDb).State = EntityState.Modified;
                    _context.SaveChanges();
                    user = _context.Users.Include(r => r.Role).FirstOrDefault(u => u.UserId == uId);
                }
            }
            return Page();
        }

        public IActionResult OnPostUpdatePassword()
        {
            int userId = int.Parse(HttpContext.Session.GetString("UserId"));
            user = _context.Users.Include(r => r.Role).FirstOrDefault(u => u.UserId == userId);
            Categories = _context.Categories.ToList();
            string currentPassword = Request.Form["currentPassword"];
            string newPassword = Request.Form["newPassword"];
            string confirmPassword = Request.Form["confirmPassword"];

            if (VerifyCurrentPassword(currentPassword))
            {
                if (newPassword == confirmPassword)
                {
                    if (newPassword != currentPassword)
                    {
                        int roleId = user.RoleId;
                        user.RoleId = roleId;
                        user.Password = newPassword;
                        _context.SaveChanges();
                        return RedirectToPage();
                    }
                    else
                    {
                        ModelState.AddModelError("newPassword", "New password must be different from the current password.");
                    }
                }
                else
                {
                    ModelState.AddModelError("confirmPassword", "Confirm password does not match the new password.");
                }
            }
            else
            {
                ModelState.AddModelError("currentPassword", "Current password is incorrect.");
            }
            return Page();
        }

        private bool VerifyCurrentPassword(string currentPassword)
        {
            bool isMatch = false;
            if (user.Password != null && user.Password.Equals(currentPassword, StringComparison.OrdinalIgnoreCase))
            {
                isMatch = true;
            }
            return isMatch;
        }
    }
}

Pages/UserManage/Profile.cshtml
@page
@model Project_PRN221_1.Pages.UserManage.ProfileModel
@{
}
<style>
    .profile-info input[type="text"],
    .profile-info input[type="password"],
    .profile-info input[type="email"] {
        border: none;
        border-bottom: 1px solid #ccc;
        background-color: transparent;
    }

        .profile-info input[type="text"]:read-only,
        .profile-info input[type="password"]:read-only,
        .profile-info input[type="email"]:read-only {
            border-bottom: none;
            background-color: transparent;
            color: #000;
        }

    .profile-info td {
        padding: 10px 0;
    }

        .profile-info td:first-child {
            width: 150px;
        }

</style>
<div class="container">
    <h1>User Profile</h1>
    <div class="row">
        <div class="col-md-6">
            <h3>Update Password</h3>
            <form method="post" asp-page-handler="UpdatePassword">
                <input type="hidden" asp-for="user.UserId" />
                <input type="hidden" asp-for="user.Password" />
                <input type="hidden" asp-for="user.Username" />
                <input type="hidden" asp-for="user.Email" />
                <input type="hidden" asp-for="user.Name" />
                <input type="hidden" asp-for="user.RoleId" />
                <input type="hidden" asp-for="user.Role" />
                <div asp-validation-summary="All" class="text-danger"></div>
                <div class="form-group">
                    <label for="currentPassword">Current Password:</label>
                    <input type="password" class="form-control" id="currentPassword" name="currentPassword" required />
                </div>

                <div class="form-group">
                    <label for="newPassword">New Password:</label>
                    <input type="password" class="form-control" id="newPassword" name="newPassword" required />
                </div>

                <div class="form-group">
                    <label for="confirmPassword">Confirm New Password:</label>
                    <input type="password" class="form-control" id="confirmPassword" name="confirmPassword" required />
                </div>

                <button type="submit" class="btn btn-primary">Update Password</button>
            </form>
        </div>
        <div class="col-md-6">
            <h3>User Profile Info</h3>
            <form method="post" asp-page-handler="UpdateProfile">
                <table class="profile-info">
                    <input type="hidden" asp-for="user.UserId" />
                    <input type="hidden" asp-for="user.Password" />
                    <tr>
                        <td><strong>User name:</strong></td>
                        <td><input type="text" asp-for="user.Username" readonly="readonly" class="form-control" id="username"/></td>
                    </tr>
                    <tr>
                        <td><strong>Email:</strong></td>
                        <td><input type="text" asp-for="user.Email" readonly="readonly" class="form-control" /></td>
                    </tr>
                    <tr>
                        <td><strong>Real name:</strong></td>
                        <td><input type="text" asp-for="user.Name" readonly="readonly" class="form-control" /></td>
                    </tr>
                    <tr>
                        <td><strong>Role:</strong></td>
                        <td>@Html.DisplayFor(model => model.user.Role.RoleName)</td>
                    </tr>
                </table>

                <button type="submit" class="btn btn-primary" id="saveButton" style="display: @((ViewData.ModelState.IsValid) ? "none" : "inline-block");">Save</button>
            </form>
            <button class="btn btn-primary" id="editButton" style="display: @((ViewData.ModelState.IsValid) ? "inline-block" : "none");">Edit Profile</button>
        </div>
    </div>
</div>

@section Scripts {
    <script>
        document.addEventListener("DOMContentLoaded", function () {
            var inputs = document.querySelectorAll('.profile-info input:not([name="id"]):not([name="role"]):not([id="username"])');
            var editButton = document.getElementById('editButton');
            var saveButton = document.getElementById('saveButton');
            if (saveButton.style.display === 'inline-block') {
                inputs.forEach(function (input) {
                    input.removeAttribute('readonly');
                });
            }
            editButton.addEventListener('click', function () {
                inputs.forEach(function (input) {
                    input.removeAttribute('readonly');
                });
                editButton.style.display = 'none';
                saveButton.style.display = 'inline-block';
            });

            saveButton.addEventListener('click', function () {
                if (saveButton.style.display === 'inline-block') {
                    inputs.forEach(function (input) {
                        input.setAttribute('readonly', 'readonly');
                    });
                }
                else {
                    editButton.style.display = 'inline-block';
                }
            });
        });
    </script>
}